@ECHO OFF
rem Nnecessary ext. tools (lib.exe mspdb100.dll msvcr100.dll)
SET ORGPATH=%PATH%

if "%CommonProgramFiles(x86)%"=="" (goto X32) else (goto x64)

:X32
FOR /F "usebackq" %%t IN (`83 "%ProgramFiles%\BestTech\GCC Developer Lite\GCC\"`) DO SET GCCBIN=%%t
GOTO INPUT

:X64
FOR /F "usebackq" %%t IN (`83 "%ProgramFiles(x86)%\BestTech\GCC Developer Lite\GCC\"`) DO SET GCCBIN=%%t
GOTO INPUT

:INPUT

if not exist %GCCBIN% goto err

echo #### 32bit ####
SET PATH=%GCCBIN%x86\bin;%ORGPATH%
gcc -shared -o rslib_x32.dll rslib.c -O3 -static-libgcc -Wall -Wno-main -Wnested-externs -Wshadow -Wcast-align -Wimplicit -Wpointer-arith -Wswitch -Wredundant-decls -Wreturn-type -Wshadow -Wunused -Wl,--add-stdcall-alias,--output-def,rslib_x32.def,--out-implib,librslib_x32.a
if not exist lib.exe goto err
lib /DEF:rslib_x32.def /MACHINE:X86 /out:rslib_x32.lib

echo #### 64bit ####
SET PATH=%GCCBIN%x64\bin;%ORGPATH%
gcc -shared -o rslib_x64.dll rslib.c -O3 -Wall -Wno-main -Wnested-externs -Wshadow -Wcast-align -Wimplicit -Wpointer-arith -Wswitch -Wredundant-decls -Wreturn-type -Wshadow -Wunused -Wl,--add-stdcall-alias,--output-def,rslib_x64.def,--out-implib,librslib_x64.a
if not exist lib.exe goto err
lib /DEF:rslib_x64.def /MACHINE:X64 /out:rslib_x64.lib
goto ok

:err
echo ---------------------------
echo !! create lib error !!
echo ---------------------------
goto fin

:ok
echo ---------------------------
echo !! create lib success !!
echo ---------------------------

goto fin

:fin
copy rslib*.dll .\SampleCode.
copy *.h .\SampleCode.
pause
SET PATH=%ORGPATH%
